searchNodes=[{"type":"module","title":"Meeseeks","doc":"Meeseeks is an Elixir library for parsing and extracting data from HTML and XML with CSS or XPath selectors. import Meeseeks.CSS html = HTTPoison . get! ( &quot;https://news.ycombinator.com/&quot; ) . body for story &lt;- Meeseeks . all ( html , css ( &quot;tr.athing&quot; ) ) do title = Meeseeks . one ( story , css ( &quot;.title a&quot; ) ) %{ title : Meeseeks . text ( title ) , url : Meeseeks . attr ( title , &quot;href&quot; ) } end #=&gt; [%{title: &quot;...&quot;, url: &quot;...&quot;}, %{title: &quot;...&quot;, url: &quot;...&quot;}, ...] Getting Started Parse Start by parsing a source (HTML/XML string or Meeseeks.TupleTree ) into a Meeseeks.Document so that it can be queried. Meeseeks.parse/1 parses the source as HTML, but Meeseeks.parse/2 accepts a second argument of either :html or :xml that specifies how the source is parsed. document = Meeseeks . parse ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; ) #=&gt; Meeseeks.Document&lt;{...}&gt; The selection functions accept an unparsed source, parsing it as HTML, but parsing is expensive so parse ahead of time when running multiple selections on the same document. Select Next, use one of Meeseeks's selection functions - fetch_all , all , fetch_one , or one - to search for nodes. All these functions accept a queryable (a source, a document, or a Meeseeks.Result ), one or more Meeseeks.Selector s, and optionally an initial context. all returns a (possibly empty) list of results representing every node matching one of the provided selectors, while one returns a result representing the first node to match a selector (depth-first) or nil if there is no match. fetch_all and fetch_one work like all and one respectively, but wrap the result in {:ok, ...} if there is a match or return {:error, %Meeseeks.Error{type: :select, reason: :no_match}} if there is not. To generate selectors, use the css macro provided by Meeseeks.CSS or the xpath macro provided by Meeseeks.XPath . import Meeseeks.CSS result = Meeseeks . one ( document , css ( &quot;#main p&quot; ) ) #=&gt; #Meeseeks.Result&lt;{ &lt;p&gt;1&lt;/p&gt; }&gt; import Meeseeks.XPath result = Meeseeks . one ( document , xpath ( &quot;//*[@id=&#39;main&#39;]//p&quot; ) ) #=&gt; #Meeseeks.Result&lt;{ &lt;p&gt;1&lt;/p&gt; }&gt; Extract Retrieve information from the Meeseeks.Result with an extraction function. The extraction functions are attr , attrs , data , dataset , html , own_text , tag , text , tree . Meeseeks . tag ( result ) #=&gt; &quot;p&quot; Meeseeks . text ( result ) #=&gt; &quot;1&quot; Meeseeks . tree ( result ) #=&gt; {&quot;p&quot;, [], [&quot;1&quot;]} The extraction functions html and tree work on Meeseeks.Document s in addition to Meeseeks.Result s. Meeseeks . html ( document ) #=&gt; &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;&lt;div id=\\&quot;main\\&quot;&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&lt;/body&gt;&lt;/html&gt;&quot;","ref":"Meeseeks.html"},{"type":"function","title":"Meeseeks.all/2","doc":"Returns [Result, ...] if one or more nodes in the queryable match a selector, or [] if none do. Optionally accepts a Meeseeks.Context map. Parses the source if it is not a Meeseeks.Document or Meeseeks.Result , and may return {:error, %Meeseeks.Error{type: parser} if there is a parse error. If multiple selections are being ran on the same unparsed source, parse first to avoid unnecessary computation. Examples iex&gt; import Meeseeks.CSS iex&gt; Meeseeks . all ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; , css ( &quot;#main p&quot; ) ) |&gt; List . first ( ) # Meeseeks.Result &lt; { &lt; p &gt; 1 &lt; / p &gt; } &gt;","ref":"Meeseeks.html#all/2"},{"type":"function","title":"Meeseeks.all/3","doc":"","ref":"Meeseeks.html#all/3"},{"type":"function","title":"Meeseeks.attr/2","doc":"Returns the value of an attribute in a result, or nil if there isn't one. Nil input returns nil . Examples iex&gt; import Meeseeks.CSS iex&gt; result = Meeseeks . one ( &quot;&lt;div id=example&gt;Hi&lt;/div&gt;&quot; , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; &gt; Hi &lt; / div &gt; } &gt; iex&gt; Meeseeks . attr ( result , &quot;id&quot; ) &quot;example&quot;","ref":"Meeseeks.html#attr/2"},{"type":"function","title":"Meeseeks.attrs/1","doc":"Returns a result's attributes list, which may be empty, or nil if the result represents a node without attributes. Nil input returns nil . Examples iex&gt; import Meeseeks.CSS iex&gt; result = Meeseeks . one ( &quot;&lt;div id=example&gt;Hi&lt;/div&gt;&quot; , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; &gt; Hi &lt; / div &gt; } &gt; iex&gt; Meeseeks . attrs ( result ) [ { &quot;id&quot; , &quot;example&quot; } ]","ref":"Meeseeks.html#attrs/1"},{"type":"function","title":"Meeseeks.data/2","doc":"Returns the combined data of a result or the result's children, which may be an empty string. Once the data has been combined the whitespace is compacted by replacing all instances of more than one whitespace character with a single space and then trimmed. Data is the content of &lt;script&gt; or &lt;style&gt; tags, or the content of comments starting with &quot;[CDATA[&quot; and ending with &quot;]]&quot;. The latter behavior is to support the extraction of CDATA from HTML, since HTML5 parsers parse CDATA as comments. Nil input returns nil . Options :collapse_whitespace - Boolean determining whether or not to replace blocks of whitespace with a single space character. Defaults to true . :trim - Boolean determining whether or not to trim the resulting text. Defaults to true . Examples iex&gt; import Meeseeks.CSS iex&gt; result1 = Meeseeks . one ( &quot;&lt;div id=example&gt;Hi&lt;/div&gt;&quot; , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; &gt; Hi &lt; / div &gt; } &gt; iex&gt; Meeseeks . data ( result1 ) &quot;&quot; iex&gt; result2 = Meeseeks . one ( &quot;&lt;script id=example&gt;Hi&lt;/script&gt;&quot; , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; script id = &quot;example&quot; &gt; Hi &lt; / script &gt; } &gt; iex&gt; Meeseeks . data ( result2 ) &quot;Hi&quot;","ref":"Meeseeks.html#data/2"},{"type":"function","title":"Meeseeks.dataset/1","doc":"Returns a map of a result's data attributes, or nil if the result represents a node without attributes. Behaves like HTMLElement.dataset; only valid data attributes are included, and attribute names have &quot;data-&quot; removed and are converted to camelCase. See: https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement/dataset Nil input returns nil . Examples iex&gt; import Meeseeks.CSS iex&gt; result = Meeseeks . one ( &quot;&lt;div id=example data-x-val=1 data-y-val=2&gt;&lt;/div&gt;&quot; , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; data - x - val = &quot;1&quot; data - y - val = &quot;2&quot; &gt; &lt; / div &gt; } &gt; iex&gt; Meeseeks . dataset ( result ) %{ &quot;xVal&quot; =&gt; &quot;1&quot; , &quot;yVal&quot; =&gt; &quot;2&quot; }","ref":"Meeseeks.html#dataset/1"},{"type":"function","title":"Meeseeks.fetch_all/2","doc":"Returns {:ok, [Result, ...]} if one of more nodes in the queryable match a selector, or {:error, %Meeseeks.Error{type: :select, reason: :no_match}} if none do. Optionally accepts a Meeseeks.Context map. Parses the source if it is not a Meeseeks.Document or Meeseeks.Result , and may return {:error, %Meeseeks.Error{type: parser} if there is a parse error. If multiple selections are being ran on the same unparsed source, parse first to avoid unnecessary computation. Examples iex&gt; import Meeseeks.CSS iex&gt; Meeseeks . fetch_all ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; , css ( &quot;#main p&quot; ) ) |&gt; elem ( 1 ) |&gt; List . first ( ) # Meeseeks.Result &lt; { &lt; p &gt; 1 &lt; / p &gt; } &gt;","ref":"Meeseeks.html#fetch_all/2"},{"type":"function","title":"Meeseeks.fetch_all/3","doc":"","ref":"Meeseeks.html#fetch_all/3"},{"type":"function","title":"Meeseeks.fetch_one/2","doc":"Returns {:ok, Result} for the first node in the queryable (depth-first) matching a selector, or {:error, %Meeseeks.Error{type: :select, reason: :no_match}} if none do. Optionally accepts a Meeseeks.Context map. Parses the source if it is not a Meeseeks.Document or Meeseeks.Result , and may return {:error, %Meeseeks.Error{type: parser} if there is a parse error. If multiple selections are being ran on the same unparsed source, parse first to avoid unnecessary computation. Examples iex&gt; import Meeseeks.CSS iex&gt; Meeseeks . fetch_one ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; , css ( &quot;#main p&quot; ) ) |&gt; elem ( 1 ) # Meeseeks.Result &lt; { &lt; p &gt; 1 &lt; / p &gt; } &gt;","ref":"Meeseeks.html#fetch_one/2"},{"type":"function","title":"Meeseeks.fetch_one/3","doc":"","ref":"Meeseeks.html#fetch_one/3"},{"type":"function","title":"Meeseeks.html/1","doc":"Returns a string representing the combined HTML of a document or result and its descendants. Nil input returns nil . Examples iex&gt; import Meeseeks.CSS iex&gt; document = Meeseeks . parse ( &quot;&lt;div id=example&gt;Hi&lt;/div&gt;&quot; ) iex&gt; Meeseeks . html ( document ) &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;&lt;div id= \\&quot; example \\&quot; &gt;Hi&lt;/div&gt;&lt;/body&gt;&lt;/html&gt;&quot; iex&gt; result = Meeseeks . one ( document , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; &gt; Hi &lt; / div &gt; } &gt; iex&gt; Meeseeks . html ( result ) &quot;&lt;div id= \\&quot; example \\&quot; &gt;Hi&lt;/div&gt;&quot;","ref":"Meeseeks.html#html/1"},{"type":"function","title":"Meeseeks.one/2","doc":"Returns a Result for the first node in the queryable (depth-first) matching a selector, or nil if none do. Optionally accepts a Meeseeks.Context map. Parses the source if it is not a Meeseeks.Document or Meeseeks.Result , and may return {:error, %Meeseeks.Error{type: parser} if there is a parse error. If multiple selections are being ran on the same unparsed source, parse first to avoid unnecessary computation. Examples iex&gt; import Meeseeks.CSS iex&gt; Meeseeks . one ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; , css ( &quot;#main p&quot; ) ) # Meeseeks.Result &lt; { &lt; p &gt; 1 &lt; / p &gt; } &gt;","ref":"Meeseeks.html#one/2"},{"type":"function","title":"Meeseeks.one/3","doc":"","ref":"Meeseeks.html#one/3"},{"type":"function","title":"Meeseeks.own_text/2","doc":"Returns the combined text of a result or the result's children, which may be an empty string. Once the text has been combined the whitespace is compacted by replacing all instances of more than one whitespace character with a single space and then trimmed. Nil input returns nil . Options :collapse_whitespace - Boolean determining whether or not to replace blocks of whitespace with a single space character. Defaults to true . :trim - Boolean determining whether or not to trim the resulting text. Defaults to true . Examples iex&gt; import Meeseeks.CSS iex&gt; result = Meeseeks . one ( &quot;&lt;div&gt;Hello, &lt;b&gt;World!&lt;/b&gt;&lt;/div&gt;&quot; , css ( &quot;div&quot; ) ) # Meeseeks.Result &lt; { &lt; div &gt; Hello , &lt; b &gt; World ! &lt; / b &gt; &lt; / div &gt; } &gt; iex&gt; Meeseeks . own_text ( result ) &quot;Hello,&quot;","ref":"Meeseeks.html#own_text/2"},{"type":"function","title":"Meeseeks.parse/1","doc":"Parses a string or Meeseeks.TupleTree into a Meeseeks.Document . parse/1 parses as HTML, while parse/2 accepts a second argument of either :html , :xml , or tuple_tree that specifies how the source is parsed. Examples iex&gt; Meeseeks . parse ( &quot;&lt;div id=main&gt;&lt;p&gt;Hello, Meeseeks!&lt;/p&gt;&lt;/div&gt;&quot; ) # Meeseeks.Document &lt; { ... } &gt; iex&gt; Meeseeks . parse ( &quot;&lt;book&gt;&lt;author&gt;GGK&lt;/author&gt;&lt;/book&gt;&quot; , :xml ) # Meeseeks.Document &lt; { ... } &gt; iex&gt; Meeseeks . parse ( { &quot;div&quot; , [ { &quot;id&quot; , &quot;main&quot; } ] , [ { &quot;p&quot; , [ ] , [ &quot;Hello, Meeseeks!&quot; ] } ] } , :tuple_tree ) # Meeseeks.Document &lt; { ... } &gt;","ref":"Meeseeks.html#parse/1"},{"type":"function","title":"Meeseeks.parse/2","doc":"","ref":"Meeseeks.html#parse/2"},{"type":"function","title":"Meeseeks.select/3","doc":"Returns the accumulated result of walking the queryable, accumulating nodes that match a selector. Prefer all or one - select should only be used when a custom accumulator is required. Requires that a Meeseeks.Accumulator has been added to the context via Meeseeks.Context.add_accumulator/2 , and will raise an error if it hasn't. Parses the source if it is not a Meeseeks.Document or Meeseeks.Result , and may return {:error, %Meeseeks.Error{type: parser} if there is a parse error. If multiple selections are being ran on the same unparsed source, parse first to avoid unnecessary computation. Examples iex&gt; import Meeseeks.CSS iex&gt; accumulator = % Meeseeks.Accumulator.One { } iex&gt; context = Meeseeks.Context . add_accumulator ( %{ } , accumulator ) iex&gt; Meeseeks . select ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; , css ( &quot;#main p&quot; ) , context ) # Meeseeks.Result &lt; { &lt; p &gt; 1 &lt; / p &gt; } &gt;","ref":"Meeseeks.html#select/3"},{"type":"function","title":"Meeseeks.tag/1","doc":"Returns a result's tag, or nil if the result represents a node without a tag. Nil input returns nil . Examples iex&gt; import Meeseeks.CSS iex&gt; result = Meeseeks . one ( &quot;&lt;div id=example&gt;Hi&lt;/div&gt;&quot; , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; &gt; Hi &lt; / div &gt; } &gt; iex&gt; Meeseeks . tag ( result ) &quot;div&quot;","ref":"Meeseeks.html#tag/1"},{"type":"function","title":"Meeseeks.text/2","doc":"Returns the combined text of a result or the result's descendants, which may be an empty string. Once the text has been combined the whitespace is compacted by replacing all instances of more than one whitespace character with a single space and then trimmed. Nil input returns nil . Options :collapse_whitespace - Boolean determining whether or not to replace blocks of whitespace with a single space character. Defaults to true . :trim - Boolean determining whether or not to trim the resulting text. Defaults to true . Examples iex&gt; import Meeseeks.CSS iex&gt; result = Meeseeks . one ( &quot;&lt;div&gt;Hello, &lt;b&gt;World!&lt;/b&gt;&lt;/div&gt;&quot; , css ( &quot;div&quot; ) ) # Meeseeks.Result &lt; { &lt; div &gt; Hello , &lt; b &gt; World ! &lt; / b &gt; &lt; / div &gt; } &gt; iex&gt; Meeseeks . text ( result ) &quot;Hello, World!&quot;","ref":"Meeseeks.html#text/2"},{"type":"function","title":"Meeseeks.tree/1","doc":"Returns the Meeseeks.TupleTree of a document or result and its descendants. Nil input returns nil . Examples iex&gt; import Meeseeks.CSS iex&gt; document = Meeseeks . parse ( &quot;&lt;div id=example&gt;Hi&lt;/div&gt;&quot; ) iex&gt; Meeseeks . tree ( document ) [ { &quot;html&quot; , [ ] , [ { &quot;head&quot; , [ ] , [ ] } , { &quot;body&quot; , [ ] , [ { &quot;div&quot; , [ { &quot;id&quot; , &quot;example&quot; } ] , [ &quot;Hi&quot; ] } ] } ] } ] iex&gt; result = Meeseeks . one ( document , css ( &quot;#example&quot; ) ) # Meeseeks.Result &lt; { &lt; div id = &quot;example&quot; &gt; Hi &lt; / div &gt; } &gt; iex&gt; Meeseeks . tree ( result ) { &quot;div&quot; , [ { &quot;id&quot; , &quot;example&quot; } ] , [ &quot;Hi&quot; ] }","ref":"Meeseeks.html#tree/1"},{"type":"type","title":"Meeseeks.extractable/0","doc":"","ref":"Meeseeks.html#t:extractable/0"},{"type":"type","title":"Meeseeks.queryable/0","doc":"","ref":"Meeseeks.html#t:queryable/0"},{"type":"type","title":"Meeseeks.selectors/0","doc":"","ref":"Meeseeks.html#t:selectors/0"},{"type":"behaviour","title":"Meeseeks.Accumulator","doc":"Accumulator structs package some means of storing nodes selected during the selection process along with a method for checking if the selection should be terminated early and a method for returning the stored nodes. Users will not typically need to define, or even know about, accumulators, but for users trying to do things like return selected nodes as Document nodes (or even tuple-tree nodes) instead of as Results, a custom accumulator will provide the solution.","ref":"Meeseeks.Accumulator.html"},{"type":"function","title":"Meeseeks.Accumulator.add/3","doc":"Provided a document and a node id, returns an updated accumulator.","ref":"Meeseeks.Accumulator.html#add/3"},{"type":"callback","title":"Meeseeks.Accumulator.add/3","doc":"Invoked to add a selected node to the accumulator.","ref":"Meeseeks.Accumulator.html#c:add/3"},{"type":"function","title":"Meeseeks.Accumulator.complete?/1","doc":"Checks if an accumulator has reached an arbitrary state of completion and no longer wishes to be added to.","ref":"Meeseeks.Accumulator.html#complete?/1"},{"type":"callback","title":"Meeseeks.Accumulator.complete?/1","doc":"Invoked to determine if the accumulator is satisfied.","ref":"Meeseeks.Accumulator.html#c:complete?/1"},{"type":"function","title":"Meeseeks.Accumulator.return/1","doc":"Returns the values accumulated by the accumulator.","ref":"Meeseeks.Accumulator.html#return/1"},{"type":"callback","title":"Meeseeks.Accumulator.return/1","doc":"Invoked to return the accumulation.","ref":"Meeseeks.Accumulator.html#c:return/1"},{"type":"type","title":"Meeseeks.Accumulator.t/0","doc":"","ref":"Meeseeks.Accumulator.html#t:t/0"},{"type":"module","title":"Meeseeks.CSS","doc":"Compile CSS selector syntax into Meeseeks.Selector s. Supported Syntax Pattern Example Notes Basic Selectors --- --- * * Matches any for ns or tag tag div ns|tag foo|div #id div#bar , #bar .class div.baz , .baz [attr] a[href] , [lang] [^attrPrefix] div[^data-] [attr=val] a[rel=&quot;nofollow&quot;] [attr~=valIncludes] div[things~=thing1] [attr|=valDash] p[lang|=en] [attr^=valPrefix] a[href^=https:] [attr$=valSuffix] img[src$=&quot;.png&quot;] [attr*=valContaining] a[href*=admin] &amp;#8203; Pseudo Classes --- --- :first-child li:first-child :first-of-type li:first-of-type :last-child tr:last-child :last-of-type tr:last-of-type :not not(p:nth-child(even)) Selectors cannot contain combinators or the not pseudo class :nth-child(n) p:nth-child(even) Supports even, odd, 1.., or a n+ b formulas :nth-last-child(n) p:nth-last-child(2) Supports even, odd, 1.., or a n+ b formulas :nth-last-of-type(n) p:nth-last-of-type(2n+1) Supports even, odd, 1.., or a n+ b formulas :nth-of-type(n) p:nth-of-type(1) Supports even, odd, 1.., or a n+ b formulas &amp;#8203; Combinators --- --- X Y div.header .logo Y descendant of X X &gt; Y ol &gt; li Y child of X X + Y div + p Y is sibling directly after X X ~ Y div ~ p Y is any sibling after X X, Y, Z button.standard, button.alert Matches X , Y , or Z Examples iex&gt; import Meeseeks.CSS iex&gt; css ( &quot;a[href^= \\&quot; https:// \\&quot; ]&quot; ) % Meeseeks.Selector.Element { combinator : nil , selectors : [ % Meeseeks.Selector.Element.Tag { value : &quot;a&quot; } , % Meeseeks.Selector.Element.Attribute.ValuePrefix { attribute : &quot;href&quot; , value : &quot;https://&quot; } ] } iex&gt; css ( &quot;ul, ol&quot; ) [ % Meeseeks.Selector.Element { combinator : nil , selectors : [ % Meeseeks.Selector.Element.Tag { value : &quot;ul&quot; } ] } , % Meeseeks.Selector.Element { combinator : nil , selectors : [ % Meeseeks.Selector.Element.Tag { value : &quot;ol&quot; } ] } ]","ref":"Meeseeks.CSS.html"},{"type":"macro","title":"Meeseeks.CSS.css/1","doc":"Compiles a string representing CSS selector syntax into one or more Meeseeks.Selector s. When a static string literal is provided this work will be done during compilation, but if a string with interpolated values or a var is provided this work will occur at run time.","ref":"Meeseeks.CSS.html#css/1"},{"type":"module","title":"Meeseeks.Context","doc":"Context is available to both Meeseek's selection process and each individual selector, and allows for selectors to build state (or receive state from the selection mechanism). The selection process expects an accumulator , return? boolean, and matches map to exist in the context, and stores selected nodes in the accumulator , stores matching nodes than need to be filtered in the matches map, and halts selection if the return? boolean becomes true.","ref":"Meeseeks.Context.html"},{"type":"function","title":"Meeseeks.Context.accumulator_key/0","doc":"Returns the key under which the accumulator is stored in the context.","ref":"Meeseeks.Context.html#accumulator_key/0"},{"type":"function","title":"Meeseeks.Context.add_accumulator/2","doc":"Adds an accumulator to context, overriding any existing accumulator in context.","ref":"Meeseeks.Context.html#add_accumulator/2"},{"type":"function","title":"Meeseeks.Context.add_to_accumulator/3","doc":"Updates the context's accumulator with the result of calling Accumulator.add on the current accumulator with the provided document and id, and sets return? to the result of calling Accumulator.complete? on the updated accumulator if return? was not already true.","ref":"Meeseeks.Context.html#add_to_accumulator/3"},{"type":"function","title":"Meeseeks.Context.add_to_matches/3","doc":"Adds a node to a list in the context's matches map corresponding to the selector that the node matched.","ref":"Meeseeks.Context.html#add_to_matches/3"},{"type":"function","title":"Meeseeks.Context.clear_matches/1","doc":"Clears the context's matches map.","ref":"Meeseeks.Context.html#clear_matches/1"},{"type":"function","title":"Meeseeks.Context.ensure_accumulator!/1","doc":"Ensures that context contains an accumulator, returning context if it does, or raising an error if it does not.","ref":"Meeseeks.Context.html#ensure_accumulator!/1"},{"type":"function","title":"Meeseeks.Context.matches_key/0","doc":"Returns the key under which matching nodes that need to be filtered are stored in the context.","ref":"Meeseeks.Context.html#matches_key/0"},{"type":"function","title":"Meeseeks.Context.nodes_key/0","doc":"Returns the key under which the nodes currently being walked are stored in the context.","ref":"Meeseeks.Context.html#nodes_key/0"},{"type":"function","title":"Meeseeks.Context.prepare_for_selection/1","doc":"Adds keys required by selection process to the context. Used internally by Meeseeks.Select- users should have no reason to call.","ref":"Meeseeks.Context.html#prepare_for_selection/1"},{"type":"function","title":"Meeseeks.Context.return_accumulator/1","doc":"Returns the result of calling Accumulator.return on the context's accumulator.","ref":"Meeseeks.Context.html#return_accumulator/1"},{"type":"function","title":"Meeseeks.Context.return_key/0","doc":"Returns the key under which return? is stored in the context.","ref":"Meeseeks.Context.html#return_key/0"},{"type":"type","title":"Meeseeks.Context.t/0","doc":"","ref":"Meeseeks.Context.html#t:t/0"},{"type":"module","title":"Meeseeks.Document","doc":"A Meeseeks.Document represents a flattened, queryable view of an HTML document in which: The nodes (element, comment, or text) have been provided an id Parent-child relationships have been made explicit Examples The actual contents of a document become quickly unwieldy in iex, so the inspect value of a document is always #Meeseeks.Document&lt;{...}&gt; regardless of the content. The example below ignores this fact for educational purposes. tuple_tree = { &quot;html&quot; , [ ] , [ { &quot;head&quot; , [ ] , [ ] } , { &quot;body&quot; , [ ] , [ { &quot;h1&quot; , [ { &quot;id&quot; , &quot;greeting&quot; } ] , [ &quot;Hello, World!&quot; ] } , { &quot;div&quot; , [ ] , [ { &quot;p&quot; , [ ] , [ &quot;1&quot; ] } , { &quot;p&quot; , [ ] , [ &quot;2&quot; ] } , { &quot;p&quot; , [ ] , [ &quot;3&quot; ] } ] } ] } ] } document = Meeseeks . parse ( tuple_tree , :tuple_tree ) #=&gt; %Meeseeks.Document{ # id_counter: 12, # roots: [1], # nodes: %{ # 1 =&gt; %Meeseeks.Document.Element{attributes: [], children: [3, 2], # id: 1, namespace: nil, parent: nil, tag: &quot;html&quot;}, # 2 =&gt; %Meeseeks.Document.Element{attributes: [], children: [], id: 2, # namespace: nil, parent: 1, tag: &quot;head&quot;}, # 3 =&gt; %Meeseeks.Document.Element{attributes: [], children: [6, 4], id: 3, # namespace: nil, parent: 1, tag: &quot;body&quot;}, # 4 =&gt; %Meeseeks.Document.Element{attributes: [{&quot;id&quot;, &quot;greeting&quot;}], # children: [5], id: 4, namespace: nil, parent: 3, tag: &quot;h1&quot;}, # 5 =&gt; %Meeseeks.Document.Text{content: &quot;Hello, World!&quot;, id: 5, parent: 4}, # 6 =&gt; %Meeseeks.Document.Element{attributes: [], children: [7, 9, 11], # id: 6, namespace: nil, parent: 3, tag: &quot;div&quot;}, # 7 =&gt; %Meeseeks.Document.Element{attributes: [], children: [8], id: 7, # namespace: nil, parent: 6, tag: &quot;p&quot;}, # 8 =&gt; %Meeseeks.Document.Text{content: &quot;1&quot;, id: 8, parent: 7}, # 9 =&gt; %Meeseeks.Document.Element{attributes: [], children: [10], id: 9, # namespace: nil, parent: 6, tag: &quot;p&quot;}, # 10 =&gt; %Meeseeks.Document.Text{content: &quot;2&quot;, id: 10, parent: 9}, # 11 =&gt; %Meeseeks.Document.Element{attributes: [], children: [12], id: 11, # namespace: nil, parent: 6, tag: &quot;p&quot;}, # 12 =&gt; %Meeseeks.Document.Text{content: &quot;3&quot;, id: 12, parent: 11}}} Meeseeks.Document . children ( document , 6 ) #=&gt; [7, 9, 11] Meeseeks.Document . descendants ( document , 6 ) #=&gt; [7, 8, 9, 10, 11, 12]","ref":"Meeseeks.Document.html"},{"type":"function","title":"Meeseeks.Document.ancestors/2","doc":"Returns the node ids of node_id's ancestors in the context of the document. Returns the ancestors in reverse order: [parent, grandparent, ...] Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#ancestors/2"},{"type":"function","title":"Meeseeks.Document.children/2","doc":"Returns the node ids of node_id's children in the context of the document. Returns all children, not just those that are Meeseeks.Document.Element s. Returns children in depth-first order. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#children/2"},{"type":"function","title":"Meeseeks.Document.delete_node/2","doc":"Deletes the node referenced by node_id and all its descendants from the document. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#delete_node/2"},{"type":"function","title":"Meeseeks.Document.descendants/2","doc":"Returns the node ids of node_id's descendants in the context of the document. Returns all descendants, not just those that are Meeseeks.Document.Element s. Returns descendants in depth-first order. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#descendants/2"},{"type":"function","title":"Meeseeks.Document.element?/2","doc":"Checks if a node_id refers to a Meeseeks.Document.Element in the context of the document. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#element?/2"},{"type":"function","title":"Meeseeks.Document.fetch_node/2","doc":"Returns a tuple of {:ok, node}, where node is the node referred to by node_id in the context of the document, or :error.","ref":"Meeseeks.Document.html#fetch_node/2"},{"type":"function","title":"Meeseeks.Document.get_node/2","doc":"Returns the node referred to by node_id in the context of the document, or nil.","ref":"Meeseeks.Document.html#get_node/2"},{"type":"function","title":"Meeseeks.Document.get_node_ids/1","doc":"Returns all of the document's node ids. Returns node ids in depth-first order.","ref":"Meeseeks.Document.html#get_node_ids/1"},{"type":"function","title":"Meeseeks.Document.get_nodes/1","doc":"Returns all of the document's nodes. Returns nodes in depth-first order.","ref":"Meeseeks.Document.html#get_nodes/1"},{"type":"function","title":"Meeseeks.Document.get_nodes/2","doc":"Returns a list of nodes referred to by node_ids in the context of the document. Returns nodes in the same order as node_ids. Raises if any id in node_ids does not exist in the document.","ref":"Meeseeks.Document.html#get_nodes/2"},{"type":"function","title":"Meeseeks.Document.get_root_ids/1","doc":"Returns all of the document's root ids. Returns root ids in depth-first order.","ref":"Meeseeks.Document.html#get_root_ids/1"},{"type":"function","title":"Meeseeks.Document.get_root_nodes/1","doc":"Returns all of the document's root nodes. Returns nodes in depth-first order.","ref":"Meeseeks.Document.html#get_root_nodes/1"},{"type":"function","title":"Meeseeks.Document.html/1","doc":"Returns the HTML of the document.","ref":"Meeseeks.Document.html#html/1"},{"type":"function","title":"Meeseeks.Document.next_siblings/2","doc":"Returns the node ids of the siblings that come after node_id in the context of the document. Returns all of these siblings, not just those that are Meeseeks.Document.Element s. Returns siblings in depth-first order. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#next_siblings/2"},{"type":"function","title":"Meeseeks.Document.parent/2","doc":"Returns the node id of node_id's parent in the context of the document, or nil if node_id does not have a parent. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#parent/2"},{"type":"function","title":"Meeseeks.Document.previous_siblings/2","doc":"Returns the node ids of the siblings that come before node_id in the context of the document. Returns all of these siblings, not just those that are Meeseeks.Document.Element s. Returns siblings in depth-first order. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#previous_siblings/2"},{"type":"function","title":"Meeseeks.Document.siblings/2","doc":"Returns the node ids of node_id's siblings in the context of the document. Returns all siblings, including node_id itself , and not just those that are Meeseeks.Document.Element s. Returns siblings in depth-first order. Raises if node_id does not exist in the document.","ref":"Meeseeks.Document.html#siblings/2"},{"type":"function","title":"Meeseeks.Document.tree/1","doc":"Returns the Meeseeks.TupleTree of the document.","ref":"Meeseeks.Document.html#tree/1"},{"type":"type","title":"Meeseeks.Document.node_id/0","doc":"","ref":"Meeseeks.Document.html#t:node_id/0"},{"type":"type","title":"Meeseeks.Document.node_t/0","doc":"","ref":"Meeseeks.Document.html#t:node_t/0"},{"type":"type","title":"Meeseeks.Document.t/0","doc":"","ref":"Meeseeks.Document.html#t:t/0"},{"type":"module","title":"Meeseeks.Result","doc":"Results are the product of running selections on a document, and package together a node id and the Meeseeks.Document for which that id is valid. Results are generally used in one of two ways: either data, such as an element's tag, is extracted from a result, or further selections are ran using the result as a source. When a result is used as a source for further selection, the original document the result came from is used for context, meaning that questions about the results ancestors may be asked, but also that queries involving ancestors need to account for the whole document, not just the contents of the result. Examples iex&gt; import Meeseeks.CSS iex&gt; document = Meeseeks . parse ( &quot;&lt;div&gt;&lt;ul&gt;&lt;li&gt;1&lt;/li&gt;&lt;li&gt;2&lt;/li&gt;&lt;/ul&gt;&lt;/div&gt;&quot; ) # Meeseeks.Document &lt; { ... } &gt; iex&gt; ul = Meeseeks . one ( document , css ( &quot;ul&quot; ) ) # Meeseeks.Result &lt; { &lt; ul &gt; &lt; li &gt; 1 &lt; / li &gt; &lt; li &gt; 2 &lt; / li &gt; &lt; / ul &gt; } &gt; iex&gt; Meeseeks . tag ( ul ) &quot;ul&quot; iex&gt; Meeseeks . all ( ul , css ( &quot;li&quot; ) ) |&gt; List . last ( ) # Meeseeks.Result &lt; { &lt; li &gt; 2 &lt; / li &gt; } &gt;","ref":"Meeseeks.Result.html"},{"type":"function","title":"Meeseeks.Result.attr/2","doc":"Returns the value for attribute in result, or nil if there isn't one.","ref":"Meeseeks.Result.html#attr/2"},{"type":"function","title":"Meeseeks.Result.attrs/1","doc":"Returns the result's attributes list, which may be empty, or nil if result represents a node without attributes.","ref":"Meeseeks.Result.html#attrs/1"},{"type":"function","title":"Meeseeks.Result.data/2","doc":"Returns the combined data of result or result's children, which may be an empty string. Once the data has been combined the whitespace is compacted by replacing all instances of more than one whitespace character with a single space and then trimmed. Data is the content of &lt;script&gt; or &lt;style&gt; tags, or the content of comments starting with &quot;[CDATA[&quot; and ending with &quot;]]&quot;. The latter behavior is to support the extraction of CDATA from HTML, since HTML5 parsers parse CDATA as comments. Options :collapse_whitespace - Boolean determining whether or not to replace blocks of whitespace with a single space character. Defaults to true . :trim - Boolean determining whether or not to trim the resulting text. Defaults to true .","ref":"Meeseeks.Result.html#data/2"},{"type":"function","title":"Meeseeks.Result.dataset/1","doc":"Returns a map of result's data attributes, or nil if result represents a node without attributes. Behaves like HTMLElement.dataset; only valid data attributes are included, and attribute names have &quot;data-&quot; removed and are converted to camelCase. See: https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement/dataset","ref":"Meeseeks.Result.html#dataset/1"},{"type":"function","title":"Meeseeks.Result.html/1","doc":"Returns the combined HTML of result and its descendants.","ref":"Meeseeks.Result.html#html/1"},{"type":"function","title":"Meeseeks.Result.own_text/2","doc":"Returns the combined text of result or result's children, which may be an empty string. Once the text has been combined the whitespace is compacted by replacing all instances of more than one whitespace character with a single space and then trimmed. Options :collapse_whitespace - Boolean determining whether or not to replace blocks of whitespace with a single space character. Defaults to true . :trim - Boolean determining whether or not to trim the resulting text. Defaults to true .","ref":"Meeseeks.Result.html#own_text/2"},{"type":"function","title":"Meeseeks.Result.tag/1","doc":"Returns result's tag, or nil if result represents a node without a tag.","ref":"Meeseeks.Result.html#tag/1"},{"type":"function","title":"Meeseeks.Result.text/2","doc":"Returns the combined text of result or result's descendants, which may be an empty string. Once the text has been combined the whitespace is compacted by replacing all instances of more than one whitespace character with a single space and then trimmed. Options :collapse_whitespace - Boolean determining whether or not to replace blocks of whitespace with a single space character. Defaults to true . :trim - Boolean determining whether or not to trim the resulting text. Defaults to true .","ref":"Meeseeks.Result.html#text/2"},{"type":"function","title":"Meeseeks.Result.tree/1","doc":"Returns a Meeseeks.TupleTree of result and its descendants.","ref":"Meeseeks.Result.html#tree/1"},{"type":"type","title":"Meeseeks.Result.t/0","doc":"","ref":"Meeseeks.Result.html#t:t/0"},{"type":"behaviour","title":"Meeseeks.Selector","doc":"Selector structs package some method of checking if a node matches some condition with an optional Meeseeks.Selector.Combinator , an optional list of filter selectors, and an optional method of validating the Selector. For instance, the css selector ul &gt; li contains a selector ul and the associated combinator &gt; li . In Meeseeks, this selector could be represented as: alias Meeseeks.Selector.Combinator alias Meeseeks.Selector.Element % Element { selectors : [ % Element.Tag { value : &quot;ul&quot; } ] , combinator : % Combinator.ChildElements { selector : % Element { selectors : [ % Element.Tag { value : &quot;li&quot; } ] } } } Extending Meeseek's ability to query is as simple as defining a struct with the Meeseeks.Selector behaviour, and selectors provide a simple target to compile dsls to. Examples defmodule Selector.Text.Contains do use Meeseeks.Selector alias Meeseeks.Document defstruct value : &quot;&quot; def match ( selector , % Document.Text { } = text , _document , _context ) do String . contains? ( text . content , selector . value ) end def match ( _selector , _node , _document , _context ) do false end end","ref":"Meeseeks.Selector.html"},{"type":"function","title":"Meeseeks.Selector.combinator/1","doc":"Returns the selector's combinator, or nil if it does not have one.","ref":"Meeseeks.Selector.html#combinator/1"},{"type":"callback","title":"Meeseeks.Selector.combinator/1","doc":"Invoked to return the selector's combinator, or nil if it does not have one.","ref":"Meeseeks.Selector.html#c:combinator/1"},{"type":"function","title":"Meeseeks.Selector.filters/1","doc":"Returns the selector's filter selectors, which may be an empty list, or nil if it does not have any.","ref":"Meeseeks.Selector.html#filters/1"},{"type":"callback","title":"Meeseeks.Selector.filters/1","doc":"Invoked to return the selector's filter selectors, which may be an empty list, or nil if it does not have any. Filters are selectors that are applied to a list of any nodes that match the selector before they are further walked with the selector's combinator if it has one, or accumulated if it does not.","ref":"Meeseeks.Selector.html#c:filters/1"},{"type":"function","title":"Meeseeks.Selector.match/4","doc":"Checks if the selector matches the node in the context of the document. Can return a boolean or a tuple of a boolean and a context.","ref":"Meeseeks.Selector.html#match/4"},{"type":"callback","title":"Meeseeks.Selector.match/4","doc":"Invoked in order to check if the selector matches the node in the context of the document. Can return a boolean or a tuple of a boolean and a context.","ref":"Meeseeks.Selector.html#c:match/4"},{"type":"function","title":"Meeseeks.Selector.validate/1","doc":"Validates selector, returning {:ok, selector} if the selector is valid or {:error, %Meeseeks.Error{}} if it is not.","ref":"Meeseeks.Selector.html#validate/1"},{"type":"callback","title":"Meeseeks.Selector.validate/1","doc":"Invoked to validate a selector, returning {:ok, selector} if the selector is valid or {:error, reason} if it is not. Selector validation can be useful in instances where a selector has been built dynamically (parsed from a string, for instance). See the Meeseeks.Selector.Element.PseudoClass.* selectors for examples. Meeseek's selection process doesn't call validate anywhere, so there is no selection-time cost for providing a validator.","ref":"Meeseeks.Selector.html#c:validate/1"},{"type":"function","title":"Meeseeks.Selector.validate!/1","doc":"Validates selector, returning the selector if it is valid or raising a Meeseeks.Error if it is not.","ref":"Meeseeks.Selector.html#validate!/1"},{"type":"type","title":"Meeseeks.Selector.t/0","doc":"","ref":"Meeseeks.Selector.html#t:t/0"},{"type":"behaviour","title":"Meeseeks.Selector.Combinator","doc":"Combinator structs package some method for finding related nodes and a Meeseeks.Selector to be run on found nodes. For instance, the css selector ul &gt; li contains the combinator &gt; li , which roughly translates to &quot;find a node's children and match any that are li s.&quot; In Meeseeks, this combinator could be represented as: alias Meeseeks.Selector.Combinator alias Meeseeks.Selector.Element % Combinator.ChildElements { selector : % Element { selectors : [ % Element.Tag { value : &quot;li&quot; } ] } } When defining a combinator using use Meeseeks.Selector.Combinator , the default implementation of selector/1 expects the selector to be stored in field selector . If this is different in your struct, you must implement selector/1 . Examples defmodule Selector.Combinator.Parent do use Meeseeks.Selector.Combinator defstruct selector : nil def next ( _combinator , node , _document ) do node . parent end end","ref":"Meeseeks.Selector.Combinator.html"},{"type":"function","title":"Meeseeks.Selector.Combinator.next/3","doc":"Finds the node or nodes that a combinator wishes its selector to be run on. Returns the applicable node or nodes, or nil if there are no applicable nodes.","ref":"Meeseeks.Selector.Combinator.html#next/3"},{"type":"callback","title":"Meeseeks.Selector.Combinator.next/3","doc":"Invoked in order to find the node or nodes that a combinator wishes its selector to be run on. Returns the applicable node or nodes, or nil if there are no applicable nodes.","ref":"Meeseeks.Selector.Combinator.html#c:next/3"},{"type":"function","title":"Meeseeks.Selector.Combinator.selector/1","doc":"Returns the combinator's selector.","ref":"Meeseeks.Selector.Combinator.html#selector/1"},{"type":"callback","title":"Meeseeks.Selector.Combinator.selector/1","doc":"Invoked to return the combinator's selector.","ref":"Meeseeks.Selector.Combinator.html#c:selector/1"},{"type":"type","title":"Meeseeks.Selector.Combinator.t/0","doc":"","ref":"Meeseeks.Selector.Combinator.html#t:t/0"},{"type":"module","title":"Meeseeks.TupleTree","doc":"HTML documents in Elixir/Erlang have traditionally been represented by a tuple tree like: { &quot;html&quot; , [ ] , [ { &quot;head&quot; , [ ] , [ ] } , { &quot;body&quot; , [ ] , [ { &quot;h1&quot; , [ { &quot;id&quot; , &quot;greeting&quot; } ] , [ &quot;Hello, World!&quot; ] } ] } ] } To parse a tuple tree use Meeseeks.parse(tuple_tree, :tuple_tree)","ref":"Meeseeks.TupleTree.html"},{"type":"type","title":"Meeseeks.TupleTree.child_node_t/0","doc":"","ref":"Meeseeks.TupleTree.html#t:child_node_t/0"},{"type":"type","title":"Meeseeks.TupleTree.comment/0","doc":"","ref":"Meeseeks.TupleTree.html#t:comment/0"},{"type":"type","title":"Meeseeks.TupleTree.doctype/0","doc":"","ref":"Meeseeks.TupleTree.html#t:doctype/0"},{"type":"type","title":"Meeseeks.TupleTree.element/0","doc":"","ref":"Meeseeks.TupleTree.html#t:element/0"},{"type":"type","title":"Meeseeks.TupleTree.processing_instruction/0","doc":"","ref":"Meeseeks.TupleTree.html#t:processing_instruction/0"},{"type":"type","title":"Meeseeks.TupleTree.root_node_t/0","doc":"","ref":"Meeseeks.TupleTree.html#t:root_node_t/0"},{"type":"type","title":"Meeseeks.TupleTree.t/0","doc":"","ref":"Meeseeks.TupleTree.html#t:t/0"},{"type":"type","title":"Meeseeks.TupleTree.text/0","doc":"","ref":"Meeseeks.TupleTree.html#t:text/0"},{"type":"module","title":"Meeseeks.XPath","doc":"Compile XPath 1.0 selector syntax into Meeseeks.Selector s. Supported Syntax Supports almost all XPath 1.0 syntax with a few notable exceptions. No top-level filter expressions Due to the way Meeseeks selection works, top-level filter expressions like xpath(&quot;(//ol|//ul)[2]&quot;) , which would select the second list element in the document, are particularly difficult to implement. An error will be raised if you try to use the above or any other top-level filter expression. To do the above try something like: Meeseeks . all ( doc , xpath ( &quot;ol|ul&quot; ) ) |&gt; Enum . at ( 1 ) All other filter expressions, like xpath(&quot;//div[2]&quot;) , are valid. No attribute steps outside of predicates Due both to how selection works and how attributes are represented in documents (stored as part of an element, rather than as a separate node) there is no easy way to implement attribute selection, and use of attributes steps are prohibited outside of predicates and will raise an error. For example, xpath(&quot;//p[@class]&quot;) which returns elements with class attributes is allowed, but xpath(&quot;//p/@class&quot;) which would return the class attributes themselves is prohibited. To extract a selected element's attribute use the attr extractor. Meeseeks . all ( doc , xpath ( &quot;//p[@class]&quot; ) ) |&gt; Enum . map ( &amp; Meeseeks . attr ( &amp;1 , &quot;class&quot; ) ) No support for variable references Variable references are not currently supported, meaning expression like xpath(&quot;*[position()=$p]&quot;) are invalid and will raise an error. To do the above try something like: p = 2 xpath ( &quot;*[position()=&quot; &lt;&gt; Integer . to_string ( p ) &lt;&gt; &quot;]&quot; ) No support for id(), lang(), or translate() functions These three functions from the core functions library are not currently supported. A runtime error will be raised should they attempt to be used. Namespace prefixes are not resolved to namespace uris If you want to find a namespace, search for the namespace prefix of node, not the expanded namespace-uri. xpath(&quot;*[namespace-uri()='example']&quot;) , not xpath(&quot;*[namespace-uri()='https://example.com/ns']&quot;) HTML5 doesn't support processing instructions Because in HTML5 processing instructions as are parsed as comments, trying to select a processing instruction will not work as expected if you are using meeseeks_html5ever 's html parser. To select a processing instruction when parsing with meeseeks_html5ever 's html parser, search for comment nodes. If you've parsed a tuple-tree that had a {:pi, _} or {:pi, _, _} node, selecting processing instructions should work as expected, though if the tuple-tree is the result of parsing with :mochiweb_html , the data might be slightly mangled due to :mochiweb_html 's rather suspect decision to parse the data of all processing instructions except &lt;?php .. ?&gt; as attributes. Examples iex&gt; import Meeseeks.XPath iex&gt; xpath ( &quot;//li[last()]&quot; ) % Meeseeks.Selector.Element { combinator : % Meeseeks.Selector.Combinator.Children { selector : % Meeseeks.Selector.Element { combinator : nil , filters : [ % Meeseeks.Selector.XPath.Predicate { e : % Meeseeks.Selector.XPath.Expr.Predicate { e : % Meeseeks.Selector.XPath.Expr.Function { args : [ ] , f : :last } } } ] , selectors : [ % Meeseeks.Selector.Element.Tag { value : &quot;li&quot; } ] } } , filters : nil , selectors : [ ] } iex&gt; xpath ( &quot;//ol|//ul&quot; ) [ % Meeseeks.Selector.Element { combinator : % Meeseeks.Selector.Combinator.Children { selector : % Meeseeks.Selector.Element { combinator : nil , filters : nil , selectors : [ % Meeseeks.Selector.Element.Tag { value : &quot;ol&quot; } ] } } , filters : nil , selectors : [ ] } , % Meeseeks.Selector.Element { combinator : % Meeseeks.Selector.Combinator.Children { selector : % Meeseeks.Selector.Element { combinator : nil , filters : nil , selectors : [ % Meeseeks.Selector.Element.Tag { value : &quot;ul&quot; } ] } } , filters : nil , selectors : [ ] } ]","ref":"Meeseeks.XPath.html"},{"type":"macro","title":"Meeseeks.XPath.xpath/1","doc":"Compiles a string representing XPath selector syntax into one or more Meeseeks.Selector s. When a static string literal is provided this work will be done during compilation, but if a string with interpolated values or a var is provided this work will occur at run time.","ref":"Meeseeks.XPath.html#xpath/1"},{"type":"exception","title":"Meeseeks.Error","doc":"Meeseeks.Error provides a generic error struct implementing the Exception behaviour and containing three keys: type , reason , and metadata . type is an atom classifying the general context the error exists in, such as :parser . reason is an atom classifying the general problem, such as :invalid_input . metadata is a map containing any additional information useful for debugging the error, such as %{input: &quot;...&quot;} . Meeseeks Errors: %Meeseeks.Error{type: :select, reason: :no_match} %Meeseeks.Error{type: :select, reason: :invalid_selectors} %Meeseeks.Error{type: :context, reason: :accumulator_required} %Meeseeks.Error{type: :parser, reason: :invalid_input} %Meeseeks.Error{type: :css_selector_tokenizer, reason: :invalid_input} %Meeseeks.Error{type: :xpath_expression_parser, reason: :invalid_input} %Meeseeks.Error{type: :document, reason: :unknown_node} %Meeseeks.Error{type: :css_selector, reason: :invalid} %Meeseeks.Error{type: :css_selector, reason: :invalid_input} %Meeseeks.Error{type: :css_selector_parser, reason: :invalid_input} %Meeseeks.Error{type: :xpath_expression, reason: :invalid_arguments} %Meeseeks.Error{type: :xpath_expression, reason: :invalid_evaluated_arguments} %Meeseeks.Error{type: :xpath_selector, reason: :invalid} %Meeseeks.Error{type: :xpath_selector, reason: :invalid_input}","ref":"Meeseeks.Error.html"},{"type":"function","title":"Meeseeks.Error.list_errors/0","doc":"Lists a mapping of error types to reasons for all possible Meeseeks errors.","ref":"Meeseeks.Error.html#list_errors/0"},{"type":"function","title":"Meeseeks.Error.new/3","doc":"Creates a new %Meeseeks.Error{} .","ref":"Meeseeks.Error.html#new/3"},{"type":"type","title":"Meeseeks.Error.metadata/0","doc":"","ref":"Meeseeks.Error.html#t:metadata/0"},{"type":"type","title":"Meeseeks.Error.reason/0","doc":"","ref":"Meeseeks.Error.html#t:reason/0"},{"type":"type","title":"Meeseeks.Error.t/0","doc":"","ref":"Meeseeks.Error.html#t:t/0"},{"type":"type","title":"Meeseeks.Error.type/0","doc":"","ref":"Meeseeks.Error.html#t:type/0"},{"type":"extras","title":"Meeseeks","doc":"Meeseeks Meeseeks is an Elixir library for parsing and extracting data from HTML and XML with CSS or XPath selectors. import Meeseeks.CSS html = HTTPoison . get! ( &quot;https://news.ycombinator.com/&quot; ) . body for story &lt;- Meeseeks . all ( html , css ( &quot;tr.athing&quot; ) ) do title = Meeseeks . one ( story , css ( &quot;.title a&quot; ) ) %{ title : Meeseeks . text ( title ) , url : Meeseeks . attr ( title , &quot;href&quot; ) } end #=&gt; [%{title: &quot;...&quot;, url: &quot;...&quot;}, %{title: &quot;...&quot;, url: &quot;...&quot;}, ...]","ref":"readme.html"},{"type":"extras","title":"Meeseeks - Features","doc":"Friendly API Browser-grade HTML5 parser Permissive XML parser CSS and XPath selectors Supports custom selectors Helpers to extract data from selections","ref":"readme.html#features"},{"type":"extras","title":"Meeseeks - Compatibility","doc":"Meeseeks is tested with a a minimum combination of Elixir 1.16.0 and Erlang/OTP 26.0 and a maximum combination of Elixir 1.18.0 and Erlang/OTP 27.0.","ref":"readme.html#compatibility"},{"type":"extras","title":"Meeseeks - Installation","doc":"Meeseeks depends on the Rust library html5ever via meeseeks_html5ever , but because meeseeks_html5ever provides pre-compiled NIFs via rustler_precompiled you do not need to have Rust installed to use Meeseeks. To install Meeseeks, add it to your mix.exs : defp deps do [ { :meeseeks , &quot;~&gt; 0.18.0&quot; } ] end Then run mix deps.get . Force Compilation If you need to force compilation of the Rust NIF for some reason, see the instructions here .","ref":"readme.html#installation"},{"type":"extras","title":"Meeseeks - Getting Started","doc":"Parse Start by parsing a source (HTML/XML string or Meeseeks.TupleTree ) into a Meeseeks.Document so that it can be queried. Meeseeks.parse/1 parses the source as HTML, but Meeseeks.parse/2 accepts a second argument of either :html , :xml , or :tuple_tree that specifies how the source is parsed. document = Meeseeks . parse ( &quot;&lt;div id=main&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&quot; ) #=&gt; #Meeseeks.Document&lt;{...}&gt; The selection functions accept an unparsed source, parsing it as HTML, but parsing is expensive so parse ahead of time when running multiple selections on the same document. Select Next, use one of Meeseeks's selection functions - fetch_all , all , fetch_one , or one - to search for nodes. All these functions accept a queryable (a source, a document, or a Meeseeks.Result ), one or more Meeseeks.Selector s, and optionally an initial context. all returns a (possibly empty) list of results representing every node matching one of the provided selectors, while one returns a result representing the first node to match a selector (depth-first) or nil if there is no match. fetch_all and fetch_one work like all and one respectively, but wrap the result in {:ok, ...} if there is a match or return {:error, %Meeseeks.Error{type: :select, reason: :no_match}} if there is not. To generate selectors, use the css macro provided by Meeseeks.CSS or the xpath macro provided by Meeseeks.XPath . import Meeseeks.CSS result = Meeseeks . one ( document , css ( &quot;#main p&quot; ) ) #=&gt; #Meeseeks.Result&lt;{ &lt;p&gt;1&lt;/p&gt; }&gt; import Meeseeks.XPath result = Meeseeks . one ( document , xpath ( &quot;//*[@id=&#39;main&#39;]//p&quot; ) ) #=&gt; #Meeseeks.Result&lt;{ &lt;p&gt;1&lt;/p&gt; }&gt; Extract Retrieve information from the Meeseeks.Result with an extractor. The included extractors are attr , attrs , data , dataset , html , own_text , tag , text , tree . Meeseeks . tag ( result ) #=&gt; &quot;p&quot; Meeseeks . text ( result ) #=&gt; &quot;1&quot; Meeseeks . tree ( result ) #=&gt; {&quot;p&quot;, [], [&quot;1&quot;]} The extractors html and tree work on Meeseeks.Document s in addition to Meeseeks.Result s. Meeseeks . html ( document ) #=&gt; &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;&lt;div id=\\&quot;main\\&quot;&gt;&lt;p&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;p&gt;3&lt;/p&gt;&lt;/div&gt;&lt;/body&gt;&lt;/html&gt;&quot;","ref":"readme.html#getting-started"},{"type":"extras","title":"Meeseeks - Guides","doc":"Meeseeks vs. Floki CSS Selectors XPath Selectors Custom Selectors Deployment","ref":"readme.html#guides"},{"type":"extras","title":"Meeseeks - Contributing","doc":"If you are interested in contributing please read the contribution guidelines .","ref":"readme.html#contributing"},{"type":"extras","title":"Meeseeks - License","doc":"Meeseeks is licensed under the MIT license .","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"Changelog","ref":"changelog.html"},{"type":"extras","title":"Changelog - Unreleased","doc":"","ref":"changelog.html#unreleased"},{"type":"extras","title":"Changelog - v0.18.0 (2025-06-01)","doc":"Compatibility No longer support Elixir versions under 1.16 or Erlang/OTP versions under 26.0 Support Elixir 1.16, 1.17, and 1.18 as well as Erlang/OTP 26.0 and 27.0","ref":"changelog.html#v0-18-0-2025-06-01"},{"type":"extras","title":"Changelog - v0.17.0 (2023-03-27)","doc":"Compatibility No longer support Elixir versions under 1.12 or Erlang/OTP versions under 23.0 Support Elixir 1.13 and 1.14 and Erlang/OTP 25.0 Enhancements Update to meeseeks_html5ever v0.14.3 , which supports NIF precompilation","ref":"changelog.html#v0-17-0-2023-03-27"},{"type":"extras","title":"Changelog - v0.16.1 (2021-10-20)","doc":"Compatibility Use meeseeks_html5ever v0.13.1 , which supports compilation on Apple M1","ref":"changelog.html#v0-16-1-2021-10-20"},{"type":"extras","title":"Changelog - v0.16.0 (2021-06-24)","doc":"Compatibility No longer support Elixir 1.6 or Erlang/OTP 20 Support Elixir 1.12 and Erlang/OTP 24 Use meeseeks_html5ever v0.13.0 , which supports Erlang/OTP 24","ref":"changelog.html#v0-16-0-2021-06-24"},{"type":"extras","title":"Changelog - v0.15.1 (2020-05-27)","doc":"Fixes [Select] Support unicode characters in XPath selectors","ref":"changelog.html#v0-15-1-2020-05-27"},{"type":"extras","title":"Changelog - v0.15.0 (2020-02-16)","doc":"Compatibility Support Elixir 1.10 Enhancements [Parse] Prevent tuple tree parser from accepting invalid input [Select] Prohibit XPath attributes steps outside of predicates","ref":"changelog.html#v0-15-0-2020-02-16"},{"type":"extras","title":"Changelog - v0.14.0 (2019-09-30)","doc":"Breaking [Extract] The private Document.Node behaviour was removed, so any direct use of its callbacks with nodes will be broken [Extract] Comments no longer have spaces added around the content when encoding to HTML, so html output may be slightly different than before [Extract] A space is now only added between nodes by text extractors if the previous sibling's text didn't end in whitespace, so data , own_text , and text output may be slightly different than before Enhancements [Extract] Refactor extractors, removing the Document.Node behaviour and adding that functionality to modules under Meeseeks.Extractor [Extract] Use iodata in string building extractors instead of string concatenation [Extract] Optimize how whitespace is collapsed by text extractors [Extract] Document which extractors collapse whitespace and make it optional (on by default) Fixes [Extract] Remove incorrectly added whitespace when encoding comments to HTML [Extract] No longer add space between nodes when extracting text if the previous sibling's text ended in whitespace","ref":"changelog.html#v0-14-0-2019-09-30"},{"type":"extras","title":"Changelog - v0.13.1 (2019-09-09)","doc":"Enhancements [Parse] Update to meeseeks_html5ever v0.12.1 , which uses a dirty scheduler for the NIF instead of working asynchronously","ref":"changelog.html#v0-13-1-2019-09-09"},{"type":"extras","title":"Changelog - v0.13.0 (2019-09-08)","doc":"Compatibility No longer support Elixir 1.4, Elixir 1.5, or Erlang/OTP 19 (minimum tested compatibility is now Elixir 1.6 and Erlang/OTP 20) Support Elixir 1.9 and Erlang/OTP 22 Fixes [Parse] Update to meeseeks_html5ever v0.12.0 , which supports Erlang/OTP 22","ref":"changelog.html#v0-13-0-2019-09-08"},{"type":"extras","title":"Changelog - v0.12.0 (2019-07-25)","doc":"Breaking [Extract] Meeseeks.html/1 now escapes problematic characters when encoding attribute values and text, so its output may be slightly different than before Fixes [Extract] Always use double quotes and escape &amp; and &quot; when encoding attribute values with Meeseeks.html/1 [Extract] Escape &lt; , &gt; , and &amp; when encoding text with Meeseeks.html/1","ref":"changelog.html#v0-12-0-2019-07-25"},{"type":"extras","title":"Changelog - v0.11.2 (2019-07-21)","doc":"Fixes [Select] Support escaped characters in CSS selector names, idents, and strings [Select] Support Elixir-style unicode code points in CSS selector names, idents, and strings [Select] Add better errors when parsing CSS selectors","ref":"changelog.html#v0-11-2-2019-07-21"},{"type":"extras","title":"Changelog - v0.11.1 (2019-06-28)","doc":"Deprecations [Parse] Deprecate parsing tuple trees with parse/1 Enhancements [Parse] Add :tuple_tree type to parse/2 Fixes [Parse] Update to meeseeks_html5ever v0.11.1 , which returns a better error when provided with non-UTF-8 input [Parse] Return parser errors if parsing an invalid tuple tree","ref":"changelog.html#v0-11-1-2019-06-28"},{"type":"extras","title":"Changelog - v0.11.0 (2019-02-28)","doc":"Compatibility No longer support Elixir 1.3 (minimum tested compatibility is now Elixir 1.4 and Erlang/OTP 19.3) Support Elixir 1.8 Enhancements [Parse] Update to meeseeks_html5ever v0.11.0 , which is faster and more memory efficient on Erlang/OTP 21","ref":"changelog.html#v0-11-0-2019-02-28"},{"type":"extras","title":"Changelog - v0.10.1 (2018-09-27)","doc":"[Meta] Test more Elixir+OTP combinations with Travis CI","ref":"changelog.html#v0-10-1-2018-09-27"},{"type":"extras","title":"Changelog - v0.10.0 (2018-07-06)","doc":"Fixes [Parse] Update to meeseeks_html5ever v0.10.0 , which supports OTP 21","ref":"changelog.html#v0-10-0-2018-07-06"},{"type":"extras","title":"Changelog - v0.9.5 (2018-06-23)","doc":"Fixes [Select] Remove optimization in Select.handle_match that could indirectly cause matches stored in the context for filtering to be prematurely cleared","ref":"changelog.html#v0-9-5-2018-06-23"},{"type":"extras","title":"Changelog - v0.9.4 (2018-06-22)","doc":"Fixes [Select] Fix error in how context was updated in Select.filter_nodes [Select] Fix error in how context was updated in XPath.Expr.Step.eval [Select] Fix error in how nodes were filtered in XPath.Expr.Step.eval [Select] Include filters when transpiling absolute XPaths to root selectors","ref":"changelog.html#v0-9-4-2018-06-22"},{"type":"extras","title":"Changelog - v0.9.3 (2018-06-15)","doc":"Fixes [Parse] Update to meeseeks_html5ever v0.9.0 , which resolves a Dialyzer error","ref":"changelog.html#v0-9-3-2018-06-15"},{"type":"extras","title":"Changelog - v0.9.2 (2018-05-28)","doc":"Enhancements [Select] The css and xpath macros now accept vars","ref":"changelog.html#v0-9-2-2018-05-28"},{"type":"extras","title":"Changelog - v0.9.1 (2018-05-25)","doc":"Fixes [Select] Fix inconsistency in Document.get_nodes/1 [Select] Fix bug in Document.get_nodes/2 , courtesy of @asonge [Select] Fix various typespecs, courtesy of @asonge","ref":"changelog.html#v0-9-1-2018-05-25"},{"type":"extras","title":"Changelog - v0.9.0 (2018-05-15)","doc":"Breaking [Errors] Returned and raised errors throughout the project have been updated to use Meeseeks.Error instead of whatever assorted formats they were using before Enhancements [Errors] Add Meeseeks.Error , a generic error struct implementing Exception [Select] Add Meeseeks.fetch_all and Meeseeks.fetch_one Fixes [Extract] Fix bug in Meeseeks.html when encoding element attribute values that contain double quotes","ref":"changelog.html#v0-9-0-2018-05-15"},{"type":"extras","title":"Changelog - v0.8.0 (2018-04-14)","doc":"Enhancements [Select] Most Document functions now raise if an unknown node_id is provided, when before they might have raised or might have handle the situation gracefully [Select] Add get_root_ids/1 , get_node_ids/1 , and fetch_node/2 to Document [Select] Add Document.delete_note/2 , courtesy of @willbarrett [Readability] Remove Credo [Readability] Add .formatters.exs and mix format project Fixes [All] Fix various typespecs","ref":"changelog.html#v0-8-0-2018-04-14"},{"type":"extras","title":"Changelog - v0.7.7 (2018-02-08)","doc":"Fixes [Parse] Update to meeseeks_html5ever v0.8.1 , which supports OTP 20.2","ref":"changelog.html#v0-7-7-2018-02-08"},{"type":"extras","title":"Changelog - v0.7.6 (2017-09-24)","doc":"Fixes [Parse] Update to meeseeks_html5ever v0.8.0 , which removes panics related to calling mark_script_already_started and get_template_contents , and removes synchronous parsing, which did not correctly handle panics and broke the &lt;1ms contract on first call [Select] Update select functions to propagate parse errors","ref":"changelog.html#v0-7-6-2017-09-24"},{"type":"extras","title":"Changelog - v0.7.5 (2017-09-23)","doc":"Fixes [Parse] Update to meeseeks_html5ever v0.7.0 , which fixes an erroneous panic related to calling remove_from_parent on a node with no parent","ref":"changelog.html#v0-7-5-2017-09-23"},{"type":"extras","title":"Changelog - v0.7.4 (2017-09-18)","doc":"Enhancements [Extract] Update extractors to propagate nil input Fixes [Select] Fix CSS tokenization bug related to ab formulas","ref":"changelog.html#v0-7-4-2017-09-18"},{"type":"extras","title":"Changelog - v0.7.3 (2017-08-29)","doc":"Fixes [Select] Fix Elixir 1.5 related warnings","ref":"changelog.html#v0-7-3-2017-08-29"},{"type":"extras","title":"Changelog - v0.7.2 (2017-07-13)","doc":"Enhancements [Extract] Add Document.html/1 and Document.tree/1 extractors [Extract] Update Meeseeks.html/1 and Meeseeks.tree/1 to accept a Document [Extract] Update the extraction functions to return a better error when provided with invalid input Fixes [Parse] Fix doctype parsing","ref":"changelog.html#v0-7-2-2017-07-13"},{"type":"extras","title":"Changelog - v0.7.1 (2017-06-29)","doc":"Fixes [Parse] Update to meeseeks_html5ever v0.6.1 , which supports OTP 20","ref":"changelog.html#v0-7-1-2017-06-29"},{"type":"extras","title":"Changelog - v0.7.0 (2017-06-05)","doc":"Enhancements [Parse] Update to meeseeks_html5ever v0.6.0 , which supports parsing XML [Parse] Add Meeseeks.parse/2 which takes either :html or :xml as the second argument to specify how the source gets parsed [Extract] Update Meeseeks.data/1 to handle CDATA when parsing HTML","ref":"changelog.html#v0-7-0-2017-06-05"},{"type":"extras","title":"Changelog - v0.6.0 (2017-05-23)","doc":"Breaking [Select] Rename Context.new/1 to Context.prepare_for_selection/1 [Select] Rename Context.with_accumulator/2 to Context.add_accumulator/2 Enhancements [Parse] Update to meeseeks_html5ever v0.5.0 [Parse] Parse Document.ProcessingInstruction nodes from tuple-trees [Select] Support processing-instruction functionality in Meeseeks.XPath (when possible) [Select] Add a Document.ProcessingInstruction node type [Select] Add Select.select/3 and Meeseeks.select/3 [Select] Add Context.ensure_accumulator!/1","ref":"changelog.html#v0-6-0-2017-05-23"},{"type":"extras","title":"Changelog - v0.5.0 (2017-05-12)","doc":"Breaking [Select] Change the Selector.match?/3 callback to Selector.match/4 , which now takes a context and can return a {boolean, context} tuple in addition to returning a boolean. Enhancements [Select] Add XPath selector support (see Meeseeks.XPath ) [Select] Add Selector.filters/1 callback to the Selector behaviour and update selection to allow for filtering matches before proceeding [Select] Add Meeseeks.Context to allow selectors and the selection process to store state [Select] Add Meeseeks.Accumulator behaviour and update Accumulator.{All, One} to use it [Select] Add Node and Root selectors [Select] Add Ancestors , AncestorsOrSelf , Children , Descendants , DescendantsOrSelf , NextSiblings , Parent , PreviousSiblings , and Self selector combinators [Select] Add parent , ancestors , and previous_siblings queries to Document Fixes [Parse] Update to meeseeks_html5ever v0.4.6 , which correctly parses namespaced elements and doesn't try to bring in html5ever 0.16.0 [Extract] Fix html extractor to add namespaces to elements [Usability] Improve Document and Result opaque inspected values","ref":"changelog.html#v0-5-0-2017-05-12"},{"type":"extras","title":"Changelog - v0.4.1 (2017-04-10)","doc":"Enhancements [Meta] Add CI via Travis CI Fixes [Parse] Update to meeseeks_html5ever v0.4.4 , which permits Elixir 1.3 [Select] Fix CSS tokenization bug involving wildcard or pseudo-class descendants","ref":"changelog.html#v0-4-1-2017-04-10"},{"type":"extras","title":"Changelog - v0.4.0 (2017-04-08)","doc":"Enhancements [Parse] Replace html5ever_elixir with meeseeks_html5ever [Select] Allow CSS selector :not() to accept multiple selectors Fixes [Parse] Move Document.new/1 to Parser.parse_tuple_tree/1 [Select] Fix ordering in Document.get_nodes/1 and Accumulator.return/1 (for Accumulator.All )","ref":"changelog.html#v0-4-0-2017-04-08"},{"type":"extras","title":"Changelog - v0.3.1 (2017-04-03)","doc":"Enhancements [Extract] Add new dataset extractor that mimics the HTMLElement.dataset API [Usability] Raise a better error when trying to select with a string instead of selectors","ref":"changelog.html#v0-3-1-2017-04-03"},{"type":"extras","title":"Contributing","doc":"Contributing","ref":"contributing.html"},{"type":"extras","title":"Contributing - Bug Reports","doc":"If submitting a bug report please search open and closed issues first.","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing - Pull Requests","doc":"If you want to add new or change existing behavior, please submit an issue explaining what you want to add or change and why before submitting a PR. In order to submit a pull request: Fork the project Create a topic branch off of main , following branch naming conventions Push the topic branch to your fork Open pull request, following PR formatting conventions Please ensure that you also follow project conventions around code style , testing , and commit messages . By submitting a PR, you agree to license your work under the license of this project.","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Contributing - Conventions","doc":"Branch Naming Please start your branch name with one of feature , fix , or chore as applicable, then a / , then a succinct description of what the branch is about (for example, chore/contribution-guidelines ). feature indicates the addition of new functionality or enhancement of existing functionality fix indicates a fix for a bug or other existing problem chore indicates changes that don't modify how the project works, such as refactoring or adding additional tests/documentation Code Style Please run mix format prior to committing. Testing If you're submitting a bug fix, please include a test or tests that would have caught the problem. If you're submitting new features, please add tests (and documentation) as appropriate. Commit Messages Commit messages should attempt to follow the seven rules of a great Git commit message : Separate subject from body with a blank line Limit the subject line to 50 characters Capitalize the subject line Do not end the subject line with a period Use the imperative mood in the subject line Wrap the body at 72 characters Use the body to explain what and why vs. how PR Formatting The title of the PR should succinctly describe what the PR accomplishes, while the body should briefly detail how that was accomplished if it isn't evident in the title. If the PR is related to an issue or issues reference them in the first line (&quot;PR for issue #123.&quot;), but don't use keywords that would automatically close the issue (like &quot;closes #123&quot; or &quot;fixes #123&quot;). If a PR makes any breaking changes make sure those changes are highlighted in the body.","ref":"contributing.html#conventions"},{"type":"extras","title":"Meeseeks vs. Floki","doc":"Meeseeks vs. Floki Why was Meeseeks created in the same space as the earlier existing library Floki? Meeseeks was created to provide a correct-by-default solution for parsing HTML since Floki's default, :mochiweb_html -based parser is not HTML5 compliant and can produce unexpected results. When should I use Meeseeks instead of Floki? When needing to parse HTML which may not be wellformed (anything scraped), Meeseeks should be preferred to Floki with its default, :mochiweb_html -based parser (Meeseeks has no advantage in correctness over Floki with a html5ever or other HTML5 compliant parser) When needing to parse XML, Meeseeks should be preferred to Floki which doesn't include an XML parser When needing to select with XPath selectors, Meeseeks should be preferred to Floki which doesn't provide XPath selectors When needing to select with a custom selector, Meeseeks should be preferred to Floki which doesn't allow custom selectors When should I used Floki instead of Meeseeks? When needing to parse wellformed HTML without including Rust in your build process, Floki with the default :mochiweb_html -based parser should be preferred to Meeseeks which requires Rust in the build process (use of the :mochiweb_html -based parser with HTMl that may not be wellformed is not recommended) When needing to make updates to an HTML document, Floki should be preferred to Meeseeks which does not provide the ability to do so. How does Meeseeks performance compare to Floki performance? For benchmarks see Meeseeks vs. Floki Performance .","ref":"meeseeks_vs_floki.html"},{"type":"extras","title":"CSS Selectors","doc":"CSS Selectors Meeseeks.CSS supports a subset of CSS3 selectors. Supported Syntax Pattern Example Notes Basic Selectors --- --- * * Matches any for ns or tag tag div ns\\|tag foo\\|div #id div#bar , #bar .class div.baz , .baz [attr] a[href] , [lang] [^attrPrefix] div[^data-] [attr=val] a[rel=&quot;nofollow&quot;] [attr~=valIncludes] div[things~=thing1] [attr\\|=valDash] p[lang\\|=en] [attr^=valPrefix] a[href^=https:] [attr$=valSuffix] img[src$=&quot;.png&quot;] [attr*=valContaining] a[href*=admin] &amp;#8203; Pseudo Classes --- --- :first-child li:first-child :first-of-type li:first-of-type :last-child tr:last-child :last-of-type tr:last-of-type :not not(p:nth-child(even)) Selectors cannot contain combinators or the not pseudo class :nth-child(n) p:nth-child(even) Supports even, odd, 1.., or a n+ b formulas :nth-last-child(n) p:nth-last-child(2) Supports even, odd, 1.., or a n+ b formulas :nth-last-of-type(n) p:nth-last-of-type(2n+1) Supports even, odd, 1.., or a n+ b formulas :nth-of-type(n) p:nth-of-type(1) Supports even, odd, 1.., or a n+ b formulas &amp;#8203; Combinators --- --- X Y div.header .logo Y descendant of X X &gt; Y ol &gt; li Y child of X X + Y div + p Y is sibling directly after X X ~ Y div ~ p Y is any sibling after X X, Y, Z button.standard, button.alert Matches X , Y , or Z","ref":"css_selectors.html"},{"type":"extras","title":"XPath Selectors","doc":"XPath Selectors Meeseeks.XPath supports a majority of XPath 1.0 syntax with a few notable exceptions. No top-level filter expressions Due to the way selection works, top-level filter expressions like xpath(&quot;(//ol|//ul)[2]&quot;) , which would select the second list element in the document, are particularly difficult to implement. An error will be raised if you try to use the above or any other top-level filter expression. To do the above try something like: Meeseeks . all ( doc , xpath ( &quot;ol|ul&quot; ) ) |&gt; Enum . at ( 1 ) All other filter expressions, like xpath(&quot;//div[2]&quot;) , are valid. No attribute steps outside of predicates Due both to how selection works and how attributes are represented in documents (stored as part of an element, rather than as a separate node) there is no easy way to implement attribute selection, and use of attributes steps are prohibited outside of predicates and will raise an error. For example, xpath(&quot;//p[@class]&quot;) which returns elements with class attributes is allowed, but xpath(&quot;//p/@class&quot;) which would return the class attributes themselves is prohibited. To extract a selected element's attribute use the attr extractor. Meeseeks . all ( doc , xpath ( &quot;//p[@class]&quot; ) ) |&gt; Enum . map ( &amp; Meeseeks . attr ( &amp;1 , &quot;class&quot; ) ) No support for variable references Variable references are not currently supported, meaning expression like xpath(&quot;*[position()=$p]&quot;) are invalid and will raise an error. To do the above try something like: p = 2 xpath ( &quot;*[position()=&quot; &lt;&gt; Integer . to_string ( p ) &lt;&gt; &quot;]&quot; ) No support for id(), lang(), or translate() functions These three functions from the core functions library are not currently supported. A runtime error will be raised should they attempt to be used. Namespace prefixes are not resolved to namespace uris If you want to find a namespace, search for the namespace prefix of node, not the expanded namespace-uri. xpath(&quot;*[namespace-uri()='example']&quot;) , not xpath(&quot;*[namespace-uri()='https://example.com/ns']&quot;) HTML5 doesn't support processing instructions Because in HTML5 processing instructions as are parsed as comments, trying to select a processing instruction will not work as expected if you are using meeseeks_html5ever 's html parser. To select a processing instruction when parsing with meeseeks_html5ever 's html parser, search for comment nodes. If you've parsed a tuple-tree that had a {:pi, _} or {:pi, _, _} node, selecting processing instructions should work as expected, though if the tuple-tree is the result of parsing with :mochiweb_html , the data might be slightly mangled due to :mochiweb_html 's rather suspect decision to parse the data of all processing instructions except &lt;?php .. ?&gt; as attributes.","ref":"xpath_selectors.html"},{"type":"extras","title":"Custom Selectors","doc":"Custom Selectors Meeseeks is designed to have extremely extensible selectors, and creating a custom selector is as easy as defining a struct that implements the Meeseeks.Selector behaviour. defmodule CommentContainsSelector do use Meeseeks.Selector alias Meeseeks.Document defstruct value : &quot;&quot; def match ( selector , % Document.Comment { } = node , _document , _context ) do String . contains? ( node . content , selector . value ) end def match ( _selector , _node , _document , _context ) do false end end selector = % CommentContainsSelector { value : &quot;TODO&quot; } Meeseeks . one ( &quot;&lt;!-- TODO: Close vuln! --&gt;&quot; , selector ) #=&gt; #Meeseeks.Result&lt;{ &lt;!-- TODO: Close vuln! --&gt; }&gt; To learn more, check the documentation for Meeseeks.Selector and Meeseeks.Selector.Combinator","ref":"custom_selectors.html"},{"type":"extras","title":"Deployment","doc":"Deployment Meeseeks requires that the Rust compiler be installed wherever Meeseeks is compiled. Deploying to Heroku Most Heroku buildpacks for Elixir do not come with Rust installed; you will need to: Add a Rust buildpack to your app, setting it to run before Elixir; and Add a RustConfig file to your project's root directory, with RUST_SKIP_BUILD=1 set. For example: heroku buildpacks:add -i 1 https://github.com/emk/heroku-buildpack-rust.git echo &quot;RUST_SKIP_BUILD=1&quot; &gt; RustConfig Deploying with Docker Make sure Rust is installed prior to running mix deps.compile . You can see examples of what commands to include in your Dockerfile by looking at the official Rust Dockerfiles. For example, here are the commands for alpine3.11 based images. If your Dockerfile is separated into a build stage and a release stage Rust only needs to be installed on the build stage. However , your release stage will need to have libgcc installed. Alpine, for example, does not include libgcc by default and you will need to install it. RUN apk add -- no - cache libgcc You will also need to have the following environment variable set during the build stage or else mix compile will fail. RUSTFLAGS = &#39;--codegen target-feature=-crt-static&#39;","ref":"deployment.html"}]